#ifndef _GETPIXEL_C
#define _GETPIXEL_C

typedef float (*getsample_operator)(float*,int,int,int,int,int,int);
//typedef void (*setsample_operator)(float*,int,int,int,int,int,int,float);

// extrapolate by 0
static float getsample_0(float *x, int w, int h, int pd, int i, int j, int l)
{
    if (i < 0 || i >= w || j < 0 || j >= h || l < 0 || l >= pd)
        return 0;
    return x[(i+j*w)*pd + l];
}

// extrapolate by nearest value
static float getsample_1(float *x, int w, int h, int pd, int i, int j, int l)
{
    if (i < 0) i = 0;
    if (j < 0) j = 0;
    if (l < 0) l = 0;
    if (i >= w) i = w-1;
    if (j >= h) j = h-1;
    if (l >= pd) l = pd-1;
    return x[(i+j*w)*pd + l];
}

static float getsample_error(float *x, int w, int h, int pd, int i,
                             int j, int l)
{
    if (i < 0 || i >= w || j < 0 || j >= h || l < 0 || l >= pd)
        return *(int*)0;
    return x[(i+j*w)*pd + l];
}

static void setsample_0(float *x, int w, int h, int pd, int i, int j, int l,
                        float v)
{
    if (i < 0 || i >= w || j < 0 || j >= h || l < 0 || l >= pd)
        return;
    x[(i+j*w)*pd + l] = v;
}
#endif//_GETPIXEL_C
